import es
import playerlib, gamethread, cfglib, popuplib, langlib, usermsg, random

config = cfglib.AddonCFG(es.getAddonPath('bdm') + '/bdm.cfg')

config.text('BDM (BackRaw\'s DeathMatch) by BackRaw')
config.text('SETTINGS - VERSION 1.2')

config.text('\n')
config.text('***********************')
config.text(' -> Make BDM Public <- ')
config.text('***********************')
bdm_enable = config.cvar('bdm_enable', 1.2)
config.text('\n')
config.text('*********************')
config.text(' -> FF On? Noisy? <- ')
config.text('*********************')
bdm_ff = config.cvar('bdm_ff', 0, 'On = 1, Off = 0')
bdm_noisy = config.cvar('bdm_noisy', 0, 'Does another script use eventscripts_noisy? (Yes = 1, No = 0)')
config.text('\n')
config.text('*******************')
config.text(' -> BOT-WEAPONS <- ')
config.text('*******************')
bdm_bot_prim_weps = config.cvar('bdm_bot_prim_weps', 'weapon_ak47;weapon_m4a1;weapon_galil;weapon_famas', 'Primary Bot-Weapons')
bdm_bot_sec_weps = config.cvar('bdm_bot_sec_weps', 'weapon_usp;weapon_deagle;weapon_fiveseven', 'Secondary Bot-Weapons')
config.text('\n')
config.text('*******************************************************************************************')
config.text(' -> RESPAWN - SPAWN-PROTECTION - SPAWNPOINTS (spawnpoints don\'t work with this version) <- ')
config.text('*******************************************************************************************')
bdm_respawn = config.cvar('bdm_respawn', .75, 'How long should a respawn take?')
bdm_spawnprotection = config.cvar('bdm_spawnprotection', 1, 'Enable/disable spawn-protection')
bdm_spawnprotectiontime = config.cvar('bdm_spawnprotectiontime', 2, 'How long should the spawn-protection take?')
bdm_spawnprotectioncolor_t = config.cvar('bdm_spawnprotectioncolor_t', '255 0 0 105', 'Set the protection-color for Terrorists')
bdm_spawnprotectioncolor_ct = config.cvar('bdm_spawnprotectioncolor_ct', '0 0 255 105', 'Set the protection-color for Counter-Terrorists')
bdm_spawnpoints = config.cvar('bdm_spawnpoints', 1, 'Use spawn-points?')
config.text('\n')
config.text('********************************************************')
config.text(' -> REMOVE WEAPONS, ENITIES, CORPSES, AND OBJECTIVES <- ')
config.text('********************************************************')
bdm_removeweps = config.cvar('bdm_removeweps', 1, 'Should idle weapons be removed?')
bdm_removecorpses = config.cvar('bdm_removecorpses', 1, 'Should corpses be removed?')
bdm_removecorpsestime = config.cvar('bdm_removecorpsestime', 3, 'Seconds to wait before the corpses are removed')
bdm_removeobjectives = config.cvar('bdm_removeobjectives', 1, 'Should objectives be removed?')
config.text('\n')
config.text('********************************')
config.text(' -> REFILL AMMO? ENABLE AWP? <- ')
config.text('********************************')
bdm_refillammo = config.cvar('bdm_refillammo', 1, 'Should ammo be refilled? (requires eventscripts_noisy to be set to 1, like bdm_noisy 0 does)')
bdm_awp = config.cvar('bdm_awp', 0, 'Should AWP be available to use?')
config.text('\n')
config.text('*******************')
config.text(' -> Show-Damage <- ')
config.text('*******************')
bdm_sd = config.cvar('bdm_sd', 1, 'Enable/disable Show-Damage')

config.write()

bdm_menu = 0
bdm_prim_menu = 0
bdm_sec_menu = 0
never_display = 0
display = 0
random_choice = 0
bdm_playerlist = {}
scount = {}
nopopup = []

def load():
    global bdm_menu, bdm_prim_menu, bdm_sec_menu
    config.execute()
    if bdm_enable == 1:
        es.makepublic('bdm_enable')
        if bdm_noisy == 0:
            es.set('eventscripts_noisy', 1)
        if bdm_ff == 1:
            es.server.cmd('mp_friendlyfire 1')
        else:
            es.server.cmd('mp_friendlyfire 0')
    else:
        es.unload('bdm')
    bdm_menu = popuplib.easymenu('bdm_weps', '_popup_choice', menu)
    bdm_menu.settitle('Weapon-Menu')
    bdm_menu.addoption('newweps', 'New Equipment')
    bdm_menu.addoption('show_again', 'Display this menu again, and choose same weapons')
    bdm_menu.addoption('never_display', 'Never display this menu again, but choose same weapons')
    bdm_menu.addoption('random', 'Random weapons')
    bdm_sec_menu = popuplib.easymenu('bdm_sec', '_popup_choice', chosen_sec)
    bdm_sec_menu.settitle('Choose a secondary weapon')
    bdm_sec_menu.addoption('usp', 'USP')
    bdm_sec_menu.addoption('glock', 'Glock 18C')
    bdm_sec_menu.addoption('deagle', 'Desert Eagle')
    bdm_sec_menu.addoption('p228', 'P228')
    bdm_sec_menu.addoption('5-7', 'ES Five-Seven')
    bdm_sec_menu.addoption('elite', 'Dual .40 Berettas')
    bdm_prim_menu = popuplib.easymenu('bdm_prim', '_popup_choice', chosen_prim)
    bdm_prim_menu.settitle('Choose a primary weapon')
    bdm_prim_menu.addoption('m4', 'Maverick M4A1 Carbine')
    bdm_prim_menu.addoption('ak', 'Avtomat Kalashnikova - 47')
    bdm_prim_menu.addoption('galil', 'IMI Galil')
    bdm_prim_menu.addoption('famas', 'FAMAS')
    bdm_prim_menu.addoption('sg', 'SG-552 Commando')
    bdm_prim_menu.addoption('aug', 'Steyr AUG')
    bdm_prim_menu.addoption('scout', 'Steyr Scout')
    if bdm_awp == 1:
        bdm_prim_menu.addoption('awp', 'Artic Warfare Police (AWP)')
    bdm_prim_menu.addoption('m3', 'M3 Super 90 Entry')
    bdm_prim_menu.addoption('xm', 'XM1014 (M4 Super 90)')
    bdm_prim_menu.addoption('tmp', 'Tactical Mashine Pistol (TMP)')
    bdm_prim_menu.addoption('mac', 'Ingram MAC-10')
    bdm_prim_menu.addoption('mp', 'MP5-Navy')
    bdm_prim_menu.addoption('ump', 'Universal Mashine Pistol (UMP 45)')
    bdm_prim_menu.addoption('p90', 'P90')
    bdm_prim_menu.addoption('para', 'M249 Para')
    if not es.exists('saycommand', 'guns'):
        es.regsaycmd('guns', 'bdm/guns')
    if es.getplayercount() > 0:
        for player in playerlib.getUseridList('#human'):
            user = playerlib.uniqueid(player, True)
            if not user in bdm_playerlist:
                default(user)
            if not user in scount:
                count(user)

def unload():
    bdm_menu.delete()
    bdm_sec_menu.delete()
    bdm_prim_menu.delete()
    bdm_playerlist.clear()
    es.unregsaycmd('guns')

def es_map_start(ev):
    if bdm_removeobjectives == 1:
        es.server.cmd('est_RemoveWeapon #t 5')
        es.server.cmd('est_Remove hostage_entity')

def weapon_reload(ev):
    if bdm_refillammo == 1:
        weaponammo(ev)

def weapon_fire_on_empty(ev):
    if bdm_refillammo == 1:
        weaponammo(ev)

def weaponammo(ev):
    user = playerlib.getPlayer(ev['userid'])
    if bdm_awp == 1:
        if ev['es_userweapon'] == 'weapon_awp':
            user.set('ammo', ['primary', '30'])
    if ev['es_userweapon'] == 'weapon_glock':
        user.set('ammo', ['secondary', '120'])
    elif ev['es_userweapon'] == 'weapon_usp':
        user.set('ammo', ['secondary', '100'])
    elif ev['es_userweapon'] == 'weapon_p228':
        user.set('ammo', ['secondary', '52'])
    elif ev['es_userweapon'] == 'weapon_deagle':
        user.set('ammo', ['secondary', '35'])
    elif ev['es_userweapon'] == 'weapon_fiveseven':
        user.set('ammo', ['secondary', '100'])
    elif ev['es_userweapon'] == 'weapon_elite':
        user.set('ammo', ['secondary', '120'])
    elif ev['es_userweapon'] == 'weapon_m4a1':
        user.set('ammo', ['primary', '90'])
    elif ev['es_userweapon'] == 'weapon_ak47':
        user.set('ammo', ['primary', '90'])
    elif ev['es_userweapon'] == 'weapon_galil':
        user.set('ammo', ['primary', '90'])
    elif ev['es_userweapon'] == 'weapon_famas':
        user.set('ammo', ['primary', '90'])
    elif ev['es_userweapon'] == 'weapon_sg552':
        user.set('ammo', ['primary', '90'])
    elif ev['es_userweapon'] == 'weapon_aug':
        user.set('ammo', ['primary', '90'])
    elif ev['es_userweapon'] == 'weapon_scout':
        user.set('ammo', ['primary', '90'])
    elif ev['es_userweapon'] == 'weapon_m3':
        user.set('ammo', ['primary', '32'])
    elif ev['es_userweapon'] == 'weapon_xm1014':
        user.set('ammo', ['primary', '32'])
    elif ev['es_userweapon'] == 'weapon_tmp':
        user.set('ammo', ['primary', '120'])
    elif ev['es_userweapon'] == 'weapon_mac10':
        user.set('ammo', ['primary', '100'])
    elif ev['es_userweapon'] == 'weapon_mp5navy':
        user.set('ammo', ['primary', '120'])
    elif ev['es_userweapon'] == 'weapon_ump45':
        user.set('ammo', ['primary', '100'])
    elif ev['es_userweapon'] == 'weapon_p90':
        user.set('ammo', ['primary', '100'])
    elif ev['es_userweapon'] == 'weapon_m249':
        user.set('ammo', ['primary', '200'])

def player_activate(ev):
    user = playerlib.uniqueid(ev['userid'], True)
    if not user in bdm_playerlist:
        default(user)
    if not user in scount:
        count(user)

def player_disconnect(ev):
    nopopup.remove(ev['userid'])

def player_spawn(ev):
    nopopup.append(ev['userid'])
    if es.getplayercount() > 0:
        es.server.cmd('est_RemoveIdle cs_ragdoll')
        es.server.cmd('est_RemoveIdle weapon')
        userid = ev['userid']
        if not ev['userid'] in nopopup:
            nopopup.append(ev['userid'])
            return
        user = playerlib.uniqueid(userid, True)
        if es.getplayersteamid(ev['userid']) != 'BOT':
            scount[user]['spawns'] += 1
            if scount[user]['spawns'] == 1 or 4:
                gamethread.delayed(3.8, usermsg.hudhint, (ev['userid'], 'Server is running BackRaw\'s Deathmatch\nType \'guns\' to change your equipment'))
                scount[user]['spawns'] = 0
            if display == 1:
                display_uid(userid)
                gamethread.delayed(.1, bdm_menu.send, (userid))
            elif never_display == 1:
                never_disp_uid(userid)
            elif random_choice == 1:
                giveenities(userid)
                randomweps(userid)
            else:
                bdm_menu.send(userid)
        else:
            giveenities(userid)
            giveweps_bot(userid)
        if bdm_spawnprotection == 1:
            es.server.cmd('est_God %s 1' % userid)
            if ev['es_userteam'] == '2':
                es.server.cmd('est_SetPlayerColor %s %s' % (userid, bdm_spawnprotectioncolor_t))
            else:
                es.server.cmd('est_SetPlayerColor %s %s' % (userid, bdm_spawnprotectioncolor_ct))
            gamethread.delayed(bdm_spawnprotectiontime, es.server.cmd, ('est_God %s 0' % userid))
            gamethread.delayed(bdm_spawnprotectiontime, es.server.cmd, ('est_SetPlayerColor %s 255 255 255 255 1' % userid))

def player_hurt(ev):
    if bdm_sd == 1:
        es.centertell(ev['attacker'], 'Damage Given: %s' % ev['dmg_health'])
        usermsg.hudhint(ev['userid'], 'Damage Taken: %s' % ev['dmg_health'])

def player_death(ev):
    if es.getplayercount() > 0:
        es.server.cmd('est_RemoveIdle weapon')
        gamethread.delayed(bdm_respawn, es.server.cmd, ('est_Spawn %s' % ev['userid']))
        if bdm_removecorpses == 1:
            gamethread.delayed(bdm_removecorpsestime, es.server.cmd, ('est_RemoveIdle cs_ragdoll'))
        if ev['headshot'] == '1':
            es.server.cmd('es_xgive %s weapon_hegrenade' % ev['attacker'])
        elif ev['weapon'] == 'hegrenade' or 'knife':
            es.server.cmd('es_xgive %s weapon_hegrenade' % ev['attacker'])

def round_start(ev):
    if es.getplayercount() > 0:
        if bdm_removeweps == 1:
            es.server.cmd('est_RemoveIdle weapon')
        if bdm_removecorpses == 1:
            gamethread.delayed(bdm_removecorpsestime, es.server.cmd, ('est_RemoveIdle cs_ragdoll'))
        if bdm_removeobjectives == 1:
            es.server.cmd('est_RemoveWeapon #t 5')
            es.server.cmd('est_Remove hostage_entity')
            for userid in playerlib.getUseridList('#all'):
                es.server.cmd('es_xfire %s func_buyzone disable;es_xfire %s func_bomb_target disable;es_xfire %s func_hostage_rescue disable' % (userid, userid, userid))

def default(user):
    global bdm_playerlist
    bdm_playerlist[user] = {}
    bdm_playerlist[user]['secondary'] = '0'
    bdm_playerlist[user]['primary'] = '0'
    bdm_playerlist[user]['random_sec'] = '0'
    bdm_playerlist[user]['random_prim'] = '0'

def count(user):
    global scount
    scount[user] = {}
    scount[user]['spawns'] = 0

def guns():
    global never_display, display, bdm_playerlist
    never_display = 0
    display = 0
    userid = es.getcmduserid()
    user = playerlib.uniqueid(userid, True)
    bdm_playerlist[user]['secondary'] = '0'
    bdm_playerlist[user]['primary'] = '0'
    bdm_playerlist[user]['random_sec'] = '0'
    bdm_playerlist[user]['random_prim'] = '0'
    bdm_menu.send(userid)

def display_uid(userid):
    global never_display, display
    if es.getplayercount() > 0:
        never_display = 0
        display = 1
        strip_player(userid)
        gamethread.delayed(0, giveweps_sec, (userid))
        gamethread.delayed(.1, es.sexec, (userid, 'use slot2'))
        gamethread.delayed(.1, giveweps_prim, (userid))

def never_disp_uid(userid):
    global never_display, display
    if es.getplayercount() > 0:
        never_display = 1
        display = 0
        strip_player(userid)
        gamethread.delayed(0, giveweps_sec, (userid))
        gamethread.delayed(.1, es.sexec, (userid, 'use slot2'))
        gamethread.delayed(.1, giveweps_prim, (userid))
    
def menu(userid, choice, popupid):
    global never_display, display, random_choice
    if es.getplayersteamid(userid) != 'BOT':
        user = playerlib.uniqueid(userid, True)
        sec = bdm_playerlist[user]['secondary'].startswith('weapon_')
        prim = bdm_playerlist[user]['primary'].startswith('weapon_')
        if choice == 'newweps':
            never_display = 0
            display = 0
            bdm_sec_menu.send(userid)
        elif choice == 'show_again':
            if sec or prim:
                display_uid(userid)
            else:
                never_display = 0
                display = 0
                bdm_menu.send(userid)
        elif choice == 'never_display':
            if sec or prim:
                never_disp_uid(userid)
            else:
                never_display = 0
                display = 0
                bdm_menu.send(userid)
        elif choice == 'random':
            never_display = 0
            display = 0
            random_choice = 1
            randomweps(userid)
        else:
            bdm_menu.send(userid)

def chosen_sec(userid, choice, popupid):
    global bdm_playerlist
    user = playerlib.uniqueid(userid, True)
    if choice == 'usp':
        bdm_playerlist[user]['secondary'] = 'weapon_usp'
        strip_player(userid)
        gamethread.delayed(0, giveweps_sec, (userid))
        gamethread.delayed(.1, es.sexec, (userid, 'use slot2'))
        bdm_prim_menu.send(userid)
    elif choice == 'glock':
        bdm_playerlist[user]['secondary'] = 'weapon_glock'
        strip_player(userid)
        gamethread.delayed(0, giveweps_sec, (userid))
        gamethread.delayed(.1, es.sexec, (userid, 'use slot2'))
        bdm_prim_menu.send(userid)
    elif choice == 'p228':
        bdm_playerlist[user]['secondary'] = 'weapon_p228'
        strip_player(userid)
        gamethread.delayed(0, giveweps_sec, (userid))
        gamethread.delayed(.1, es.sexec, (userid, 'use slot2'))
        bdm_prim_menu.send(userid)
    elif choice == 'deagle':
        bdm_playerlist[user]['secondary'] = 'weapon_deagle'
        strip_player(userid)
        gamethread.delayed(0, giveweps_sec, (userid))
        gamethread.delayed(.1, es.sexec, (userid, 'use slot2'))
        bdm_prim_menu.send(userid)
    elif choice == '5-7':
        bdm_playerlist[user]['secondary'] = 'weapon_fiveseven'
        strip_player(userid)
        gamethread.delayed(0, giveweps_sec, (userid))
        gamethread.delayed(.1, es.sexec, (userid, 'use slot2'))
        bdm_prim_menu.send(userid)
    elif choice == 'elite':
        bdm_playerlist[user]['secondary'] = 'weapon_elite'
        strip_player(userid)
        gamethread.delayed(0, giveweps_sec, (userid))
        gamethread.delayed(.1, es.sexec, (userid, 'use slot2'))
        bdm_prim_menu.send(userid)
    else:
        bdm_playerlist[user]['secondary'] = 'none'
        bdm_prim_menu.send(userid)

def chosen_prim(userid, choice, popupid):
    global bdm_playerwep
    user = playerlib.uniqueid(userid, True)
    if choice == 'm4':
        bdm_playerlist[user]['primary'] = 'weapon_m4a1'
        gamethread.delayed(0, giveweps_prim, (userid))
    elif choice == 'ak':
        bdm_playerlist[user]['primary'] = 'weapon_ak47'
        gamethread.delayed(0, giveweps_prim, (userid))
    elif choice == 'galil':
        bdm_playerlist[user]['primary'] = 'weapon_galil'
        gamethread.delayed(0, giveweps_prim, (userid))
    elif choice == 'famas':
        bdm_playerlist[user]['primary'] = 'weapon_famas'
        gamethread.delayed(0, giveweps_prim, (userid))
    elif choice == 'sg':
        bdm_playerlist[user]['primary'] = 'weapon_sg552'
        gamethread.delayed(0, giveweps_prim, (userid))
    elif choice == 'aug':
        bdm_playerlist[user]['primary'] = 'weapon_aug'
        gamethread.delayed(0, giveweps_prim, (userid))
    elif choice == 'scout':
        bdm_playerlist[user]['primary'] = 'weapon_scout'
        gamethread.delayed(0, giveweps_prim, (userid))
    elif choice == 'awp':
        bdm_playerlist[user]['primary'] = 'weapon_awp'
        gamethread.delayed(0, giveweps_prim, (userid))
    elif choice == 'm3':
        bdm_playerlist[user]['primary'] = 'weapon_m3'
        gamethread.delayed(0, giveweps_prim, (userid))
    elif choice == 'xm':
        bdm_playerlist[user]['primary'] = 'weapon_xm1014'
        gamethread.delayed(0, giveweps_prim, (userid))
    elif choice == 'tmp':
        bdm_playerlist[user]['primary'] = 'weapon_tmp'
        gamethread.delayed(0, giveweps_prim, (userid))
    elif choice == 'mac':
        bdm_playerlist[user]['primary'] = 'weapon_mac10'
        gamethread.delayed(0, giveweps_prim, (userid))
    elif choice == 'mp':
        bdm_playerlist[user]['primary'] = 'weapon_mp5navy'
        gamethread.delayed(0, giveweps_prim, (userid))
    elif choice == 'ump':
        bdm_playerlist[user]['primary'] = 'weapon_ump45'
        gamethread.delayed(0, giveweps_prim, (userid))
    elif choice == 'p90':
        bdm_playerlist[user]['primary'] = 'weapon_p90'
        gamethread.delayed(0, giveweps_prim, (userid))
    elif choice == 'para':
        bdm_playerlist[user]['primary'] = 'weapon_m249'
        gamethread.delayed(0, giveweps_prim, (userid))
    else:
        bdm_playerlist[user]['primary'] = 'none'
        gamethread.delayed(0, giveweps_prim, (userid))

def strip_player(userid):
    es.server.cmd('es_xfire %s player_weaponstrip kill' % userid)
    es.give(userid, 'player_weaponstrip')
    es.server.cmd('es_xfire %s player_weaponstrip strip' % userid)

def giveenities(userid):
    es.server.cmd('es_xgive %s weapon_knife;es_xgive %s weapon_hegrenade;es_xgive %s item_assaultsuit' % (userid, userid, userid))

def giveweps_sec(userid):
    if es.getplayersteamid(userid) != 'BOT':
        user = playerlib.uniqueid(userid, True)
        gamethread.delayed(0, giveenities, (userid))
        gamethread.delayed(0, es.give, (userid, bdm_playerlist[user]['secondary']))
        gamethread.delayed(.1, playerlib.getPlayer(userid).set, ('health', '100'))

def randomweps(userid):
    global bdm_playerlist
    if es.getplayersteamid(userid) != 'BOT':
        user = playerlib.uniqueid(userid, True)
        bdm_playerlist[user]['random_sec'] = 'weapon_glock;weapon_usp;weapon_deagle;weapon_fiveseven;weapon_elite;weapon_p228'
        if bdm_awp == 1:
            bdm_playerlist[user]['random_prim'] = 'weapon_m4a1;weapon_ak47;weapon_galil;weapon_famas;weapon_sg552;weapon_aug;weapon_scout;weapon_m3;weapon_awp;weapon_xm1014;weapon_tmp;weapon_mac10', 'weapon_mp5navy;weapon_ump45;weapon_p90;weapon_m249'
        else:
            bdm_playerlist[user]['random_prim'] = 'weapon_m4a1;weapon_ak47;weapon_galil;weapon_famas;weapon_sg552;weapon_aug;weapon_scout;weapon_m3;weapon_xm1014;weapon_tmp;weapon_mac10', 'weapon_mp5navy;weapon_ump45;weapon_p90;weapon_m249'
        sec = random.choice(str(bdm_playerlist[user]['random_sec']).split(';'))
        prim = random.choice(str(bdm_playerlist[user]['random_prim']).split(';'))
        strip_player(userid)
        gamethread.delayed(0, giveenities, (userid))
        gamethread.delayed(.1, es.give, (userid, sec))
        gamethread.delayed(.1, playerlib.getPlayer(userid).set, ('health', '100'))
        gamethread.delayed(.2, es.sexec, (userid, 'use slot2'))
        gamethread.delayed(.3, es.give, (userid, prim))
        gamethread.delayed(.3, playerlib.getPlayer(userid).set, ('health', '100'))
        gamethread.delayed(.4, es.sexec, (userid, 'use slot1'))

def giveweps_bot(userid):
    sec_weps = random.choice(str(bdm_bot_prim_weps).split(';'))
    prim_weps = random.choice(str(bdm_bot_sec_weps).split(';'))
    es.server.cmd('es_xgive %s %s;es_xgive %s %s' % (userid, sec_weps, userid, prim_weps))

def giveweps_prim(userid):
    if es.getplayersteamid(userid) != 'BOT':
        user = playerlib.uniqueid(userid, True)
        if bdm_playerlist[user]['secondary'] != '0' or 'none':
            giveweps_sec(userid)
            gamethread.delayed(.1, es.give, (userid, bdm_playerlist[user]['primary']))
            gamethread.delayed(.2, es.sexec, (userid, 'use slot1'))
        else:
            gamethread.delayed(0, giveenities, (userid))
            gamethread.delayed(.1, playerlib.getPlayer(userid).set, ('health', '100'))
            gamethread.delayed(.1, es.give, (userid, bdm_playerlist[user]['primary']))
            gamethread.delayed(.2, es.sexec, (userid, 'use slot1'))
